## Weisfeiler and Leman Go Relational: Code

The repo contains the code and models to reproduce the experiments.

Experimental environment used Python 3.9

```
torch                 1.10.0
torch-cluster         1.5.9
torch-geometric       2.0.3
torch-scatter         2.0.9
torch-sparse          0.6.12
torch-spline-conv     1.2.1
wandb                 0.12.6
```

To run the experiments, use the following commands.

* R-GCN on AIFB with initial feature dimension 4 and seed 0

```
python main.py --dataset AIFB --dim 4 --rgcn_fast --lr 0.001 --epochs 8000 --drop_bias --seed 0
```

* R-GCN + MLP on AIFB with dimension 4

```
python main.py --dataset AIFB --dim 4 --rgcn_fast --lr 0.001 --epochs 8000 --drop_bias --mod_rgcn --seed 0
```

* CompGCN on AIFB with initial feature dimension 4 

```
python main.py --dataset AIFB --dim 4 --compgcn --lr 0.001 --epochs 8000
```

* R-GCN on AIFB with initial feature dimension 4

```
python main.py --dataset AM --num_layers 3 --dim 4 --rgcn_fast --lr 0.03 --epochs 100 --drop_bias
```

* CompGCN on AIFB with initial feature dimension 4

```
python main.py --dataset AM --compgcn --dim 4 --lr 0.03 --epochs 800
```

To try out CompGCN ablations, use the respective flags:
* w/o normalization: `--no_norm`

```
python main.py --dataset AIFB --dim 4 --compgcn --lr 0.001 --epochs 8000 --no_norm
```

* w/o directionality: `--compgcn_no_dir`
* w/o relation update: `--compgcn_no_relupd`

To change the message function, use the flag `--msg_func`, eg, to put the `rotate` function, use 

```
python main.py --dataset AIFB --dim 4 --compgcn --lr 0.001 --epochs 8000 --msg_func rotate
```

Available options are `transe`, `distmult`, `rotate`.